/* Generated by GOB (v2.0.15)   (do not edit directly) */



/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc.
 *
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com>
 */

#include <glib.h>
#include <glib-object.h>


/**
 * Stroke Noise Reducer that finds farthest nodes.
 *
 * Tomoe (tomoe.sourceforge.jp) use the similar technique.
 *
 * The farthest node of given stroke segment is defined as
 * the node that is farthest from the direct line
 * between the starting node and ending node.
 * Farthest nodes are deemed to be the significant nodes,
 * because they usually represent as vertexs of strokes.
 */

/*
 * Convenient macros
 */

#ifndef STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES_H_
#define STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES_H_

#include "utils.h"
#include "WritRecogn.h"
#include "algors.h"

#endif	/*STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES_H_ */

#ifndef __WRITRECOGN_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES_H__
#define __WRITRECOGN_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/*
 * Type checking and casting macros
 */
#define WRITRECOGN_TYPE_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES	(writrecogn_stroke_noise_reducer_find_farthest_nodes_get_type())
#define WRITRECOGN_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_stroke_noise_reducer_find_farthest_nodes_get_type(), writRecognStroke_noise_reducer_find_farthest_nodes)
#define WRITRECOGN_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_stroke_noise_reducer_find_farthest_nodes_get_type(), writRecognStroke_noise_reducer_find_farthest_nodes const)
#define WRITRECOGN_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), writrecogn_stroke_noise_reducer_find_farthest_nodes_get_type(), writRecognStroke_noise_reducer_find_farthest_nodesClass)
#define WRITRECOGN_IS_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), writrecogn_stroke_noise_reducer_find_farthest_nodes_get_type ())

#define WRITRECOGN_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), writrecogn_stroke_noise_reducer_find_farthest_nodes_get_type(), writRecognStroke_noise_reducer_find_farthest_nodesClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_WRITRECOGN_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES__
#define __TYPEDEF_WRITRECOGN_STROKE_NOISE_REDUCER_FIND_FARTHEST_NODES__
typedef struct _writRecognStroke_noise_reducer_find_farthest_nodes writRecognStroke_noise_reducer_find_farthest_nodes;
#endif
struct _writRecognStroke_noise_reducer_find_farthest_nodes {
	writRecognStroke_noise_reducer __parent__;
};

/*
 * Class definition
 */
typedef struct _writRecognStroke_noise_reducer_find_farthest_nodesClass writRecognStroke_noise_reducer_find_farthest_nodesClass;
struct _writRecognStroke_noise_reducer_find_farthest_nodesClass {
	writRecognStroke_noise_reducerClass __parent__;
};


/*
 * Public methods
 */
GType	writrecogn_stroke_noise_reducer_find_farthest_nodes_get_type	(void);
StrokeNoiseReducer * 	writrecogn_stroke_noise_reducer_find_farthest_nodes_new	(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
