/* Generated by GOB (v2.0.15)   (do not edit directly) */



/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc.
 *
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com>
 */

#include <glib.h>
#include <glib-object.h>


/**
 * Stroke recognition functions
 */

#ifndef STROKE_RECOGNIZER_H_
#define STROKE_RECOGNIZER_H_

#include "WritRecogn.h"
#include "algors.h"
#endif /*STROKE_RECOGNIZER_H_ */

#ifndef __WRITRECOGN_STROKE_RECOGNIZER_H__
#define __WRITRECOGN_STROKE_RECOGNIZER_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/*
 * Type checking and casting macros
 */
#define WRITRECOGN_TYPE_STROKE_RECOGNIZER	(writrecogn_stroke_recognizer_get_type())
#define WRITRECOGN_STROKE_RECOGNIZER(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_stroke_recognizer_get_type(), writRecognStroke_recognizer)
#define WRITRECOGN_STROKE_RECOGNIZER_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_stroke_recognizer_get_type(), writRecognStroke_recognizer const)
#define WRITRECOGN_STROKE_RECOGNIZER_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), writrecogn_stroke_recognizer_get_type(), writRecognStroke_recognizerClass)
#define WRITRECOGN_IS_STROKE_RECOGNIZER(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), writrecogn_stroke_recognizer_get_type ())

#define WRITRECOGN_STROKE_RECOGNIZER_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), writrecogn_stroke_recognizer_get_type(), writRecognStroke_recognizerClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_WRITRECOGN_STROKE_RECOGNIZER__
#define __TYPEDEF_WRITRECOGN_STROKE_RECOGNIZER__
typedef struct _writRecognStroke_recognizer writRecognStroke_recognizer;
#endif
struct _writRecognStroke_recognizer {
	GObject __parent__;
	/*< private >*/
	Hypothesis * hypo; /* protected */
};

/*
 * Class definition
 */
typedef struct _writRecognStroke_recognizerClass writRecognStroke_recognizerClass;
struct _writRecognStroke_recognizerClass {
	GObjectClass __parent__;
	Radical * (* recognize) (writRecognStroke_recognizer * self, RawStroke * rStroke);
	Hypothesis * (* train) (writRecognStroke_recognizer * self, RadicalList * radicalList);
	gfloat (* get_current_training_progress) (writRecognStroke_recognizer * self);
	Hypothesis * (* get_hypothesis) (writRecognStroke_recognizer * self);
	void (* set_hypothesis) (writRecognStroke_recognizer * self, Hypothesis * hypothesis);
	gboolean (* load_hypothesis) (writRecognStroke_recognizer * self, const gchar * filename);
	gboolean (* save_hypothesis) (writRecognStroke_recognizer * self, const gchar * filename);
};


/*
 * Public methods
 */
GType	writrecogn_stroke_recognizer_get_type	(void);
Radical * 	writrecogn_stroke_recognizer_recognize	(writRecognStroke_recognizer * self,
					RawStroke * rStroke);
Hypothesis * 	writrecogn_stroke_recognizer_train	(writRecognStroke_recognizer * self,
					RadicalList * radicalList);
gfloat 	writrecogn_stroke_recognizer_get_current_training_progress	(writRecognStroke_recognizer * self);
Hypothesis * 	writrecogn_stroke_recognizer_get_hypothesis	(writRecognStroke_recognizer * self);
void 	writrecogn_stroke_recognizer_set_hypothesis	(writRecognStroke_recognizer * self,
					Hypothesis * hypothesis);
gboolean 	writrecogn_stroke_recognizer_load_hypothesis	(writRecognStroke_recognizer * self,
					const gchar * filename);
gboolean 	writrecogn_stroke_recognizer_save_hypothesis	(writRecognStroke_recognizer * self,
					const gchar * filename);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
