/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc.
 *
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com>
 */

/**
 *  File processing  meta header file.
 * 
 * This header file calls other header files in this directory (in the sense of Java package).
 */
#ifndef FILE_PROCESSING_H_
#define FILE_PROCESSING_H_
#include "WritRecogn-Types.h"

#define STROKE_DATA_NOT_LOADED_MSG "Stroke data has not been loaded, please load it before proceed training."
#define FAIL_TO_SAVE_HYPOTHESIE_FILE_MSG "Failed to save svm model in file"
#define LABEL_TEMPLATE "<span size=\"larger\">%s</span>"



extern gchar *tomoeFileName;
extern gchar *wubiFileName;
extern gchar *destFileName;

//#include "characterData.h"
//#include "characterData-XML.h"
//#include "characterData-SQLite.h"
//#include "characterData-tomoe.h"
//#include "characterData-wubi.h"
#include "RadicalQuery.h"
#include "writrecogn-character_datafile.h"
#include "writrecogn-character_datafile_sqlite.h"
#include "writrecogn-character_datafile_xml.h"
//#include "writrecogn-character_datafile_xml.h"
//#include "writrecogn-character_datafile_sqlite.h"
#include "fileFunctions-UI.h"

#endif                          /*FILE_PROCESSING_H_ */

