/* Generated by GOB (v2.0.15)   (do not edit directly) */



/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc.
 *
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com>
 */

#include <glib.h>
#include <glib-object.h>


#ifndef CHARACTER_DATAFILE_H_
#define CHARACTER_DATAFILE_H_
#include "verboseMsg.h"
#include "xmlHandler.h"
#include "WritRecogn.h"
#include "fileProcessing.h"

#define FILE_VERBOSE_LEVEL VERBOSE_MSG_INFO1
#endif /* CHARACTER_DATAFILE_H_ */

#ifndef __WRITRECOGN_CHARACTER_DATAFILE_H__
#define __WRITRECOGN_CHARACTER_DATAFILE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


typedef enum {
	FILE_OPEN_TYPE_AUTO,
	FILE_OPEN_TYPE_READ_ONLY,
	FILE_OPEN_TYPE_WRITE_ONLY,
	FILE_OPEN_TYPE_READ_WRITE
} FileOpenType;
#define FILE_TYPE_OPENTYPE file_opentype_get_type()
GType file_opentype_get_type (void);


/*
 * Type checking and casting macros
 */
#define WRITRECOGN_TYPE_CHARACTER_DATAFILE	(writrecogn_character_datafile_get_type())
#define WRITRECOGN_CHARACTER_DATAFILE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_character_datafile_get_type(), writRecognCharacter_datafile)
#define WRITRECOGN_CHARACTER_DATAFILE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_character_datafile_get_type(), writRecognCharacter_datafile const)
#define WRITRECOGN_CHARACTER_DATAFILE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), writrecogn_character_datafile_get_type(), writRecognCharacter_datafileClass)
#define WRITRECOGN_IS_CHARACTER_DATAFILE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), writrecogn_character_datafile_get_type ())

#define WRITRECOGN_CHARACTER_DATAFILE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), writrecogn_character_datafile_get_type(), writRecognCharacter_datafileClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_WRITRECOGN_CHARACTER_DATAFILE__
#define __TYPEDEF_WRITRECOGN_CHARACTER_DATAFILE__
typedef struct _writRecognCharacter_datafile writRecognCharacter_datafile;
#endif
struct _writRecognCharacter_datafile {
	GObject __parent__;
	/*< public >*/
	gboolean modified;
	gchar * message;
	LanguageSet * defaultLangSet;
	/*< private >*/
	FileOpenType openType; /* protected */
	gchar * filename; /* protected */
	RadicalList * cachedRadicalList; /* protected */
};

/*
 * Class definition
 */
typedef struct _writRecognCharacter_datafileClass writRecognCharacter_datafileClass;
struct _writRecognCharacter_datafileClass {
	GObjectClass __parent__;
	void (* free) (writRecognCharacter_datafile * self);
	gboolean (* open) (writRecognCharacter_datafile * self);
	RadicalList * (* read_radicalList) (writRecognCharacter_datafile * self);
	gboolean (* has_radicalCode) (writRecognCharacter_datafile * self, RadicalCode code);
	gboolean (* has_radical) (writRecognCharacter_datafile * self, Radical * rad, RadicalType type);
	Radical * (* read_radical) (writRecognCharacter_datafile * self, RadicalCode code, RadicalType type);
	gboolean (* insert_radical) (writRecognCharacter_datafile * self, Radical * rad);
	gboolean (* update_radical) (writRecognCharacter_datafile * self, Radical * rad);
	gboolean (* append_radicalList) (writRecognCharacter_datafile * self, RadicalList * radList);
	RadicalList * (* find_matches) (writRecognCharacter_datafile * self, RadicalQuery * query);
	gboolean (* flush) (writRecognCharacter_datafile * self);
	gboolean (* close) (writRecognCharacter_datafile * self, gboolean needFlush);
};


/*
 * Public methods
 */
GType	writrecogn_character_datafile_get_type	(void);
gint 	writrecogn_character_datafile_get_openType	(writRecognCharacter_datafile * self);
void 	writrecogn_character_datafile_set_openType	(writRecognCharacter_datafile * self,
					gint val);
gchar * 	writrecogn_character_datafile_get_filename	(writRecognCharacter_datafile * self);
void 	writrecogn_character_datafile_set_filename	(writRecognCharacter_datafile * self,
					gchar * val);
GObject * 	writrecogn_character_datafile_get_cachedRadicalList	(writRecognCharacter_datafile * self);
void 	writrecogn_character_datafile_set_cachedRadicalList	(writRecognCharacter_datafile * self,
					GObject * val);
CharacterDataFile * 	writrecogn_character_datafile_new	(void);
CharacterDataFile * 	writrecogn_character_datafile_new_from_file	(const gchar * filename,
					FileOpenType openType);
void 	writrecogn_character_datafile_free	(writRecognCharacter_datafile * self);
gboolean 	writrecogn_character_datafile_open	(writRecognCharacter_datafile * self);
RadicalList * 	writrecogn_character_datafile_read_radicalList	(writRecognCharacter_datafile * self);
gboolean 	writrecogn_character_datafile_has_radicalCode	(writRecognCharacter_datafile * self,
					RadicalCode code);
gboolean 	writrecogn_character_datafile_has_radical	(writRecognCharacter_datafile * self,
					Radical * rad,
					RadicalType type);
Radical * 	writrecogn_character_datafile_read_radical	(writRecognCharacter_datafile * self,
					RadicalCode code,
					RadicalType type);
gboolean 	writrecogn_character_datafile_insert_radical	(writRecognCharacter_datafile * self,
					Radical * rad);
gboolean 	writrecogn_character_datafile_update_radical	(writRecognCharacter_datafile * self,
					Radical * rad);
gboolean 	writrecogn_character_datafile_append_radicalList	(writRecognCharacter_datafile * self,
					RadicalList * radList);
RadicalList * 	writrecogn_character_datafile_find_matches	(writRecognCharacter_datafile * self,
					RadicalQuery * query);
gboolean 	writrecogn_character_datafile_flush	(writRecognCharacter_datafile * self);
gboolean 	writrecogn_character_datafile_close	(writRecognCharacter_datafile * self,
					gboolean needFlush);

/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define WRITRECOGN_CHARACTER_DATAFILE_PROP_OPENTYPE(arg)    	"openType", __extension__ ({gint z = (arg); z;})
#define WRITRECOGN_CHARACTER_DATAFILE_GET_PROP_OPENTYPE(arg)	"openType", __extension__ ({gint *z = (arg); z;})
#define WRITRECOGN_CHARACTER_DATAFILE_PROP_FILENAME(arg)    	"filename", __extension__ ({gchar *z = (arg); z;})
#define WRITRECOGN_CHARACTER_DATAFILE_GET_PROP_FILENAME(arg)	"filename", __extension__ ({gchar **z = (arg); z;})
#define WRITRECOGN_CHARACTER_DATAFILE_PROP_CACHEDRADICALLIST(arg)    	"cachedRadicalList", __extension__ ({GObject *z = (arg); z;})
#define WRITRECOGN_CHARACTER_DATAFILE_GET_PROP_CACHEDRADICALLIST(arg)	"cachedRadicalList", __extension__ ({GObject **z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define WRITRECOGN_CHARACTER_DATAFILE_PROP_OPENTYPE(arg)    	"openType",(gint )(arg)
#define WRITRECOGN_CHARACTER_DATAFILE_GET_PROP_OPENTYPE(arg)	"openType",(gint *)(arg)
#define WRITRECOGN_CHARACTER_DATAFILE_PROP_FILENAME(arg)    	"filename",(gchar *)(arg)
#define WRITRECOGN_CHARACTER_DATAFILE_GET_PROP_FILENAME(arg)	"filename",(gchar **)(arg)
#define WRITRECOGN_CHARACTER_DATAFILE_PROP_CACHEDRADICALLIST(arg)    	"cachedRadicalList",(GObject *)(arg)
#define WRITRECOGN_CHARACTER_DATAFILE_GET_PROP_CACHEDRADICALLIST(arg)	"cachedRadicalList",(GObject **)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
