/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *  
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc. 
 * 
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com> 
 */
#include <stdio.h>
#include <stdarg.h>
#include "str_functions.h"
#include "utils.h"

char*
initString(char *str){
    if (str==NULL){
#ifdef USE_GLIB
        str=(gchar *) NEW_INSTANCE_ARRAY(MAX_STRING_BUFFER_SIZE,gchar);
#else
        str=(char *) NEW_INSTANCE_ARRAY(MAX_STRING_BUFFER_SIZE,char);
#endif
    }
    str[0]='\0';
    return str;
}

bool
isEmptyString(const char *str){
    if (str==NULL)
        return true;
    if (strlen(str)==0)
        return true;
    return false;
}

char*
subString(char *buf, const char *str,int beginIndex,int length){
    int i=0;
    for(i=0;i<length;i++){
        buf[i]=str[beginIndex+i];
    }
    buf[i]='\0';
    return buf;
}

gchar* ucs4_to_utf8(gunichar ucs4Code){
    gchar *utf8Code;
    int len=g_unichar_to_utf8(ucs4Code,NULL);
    utf8Code=NEW_INSTANCE_ARRAY(len+1,gchar);
    g_unichar_to_utf8(ucs4Code,utf8Code);
    utf8Code[len]='\0';
    return utf8Code;
}

