/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *  
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc. 
 * 
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com> 
 */
#include <stdarg.h>
#include "verboseMsg.h" 

int _verboseLevel=VERBOSE_MSG_CRITICAL;
int _fileVerboseLevel=VERBOSE_MSG_NONE;
FILE *_outputFile;

void setVerboseLevel(int verboseLevel){
    _verboseLevel=verboseLevel;
}

void setFileVerboseLevel(int fileVerboseLevel){
    _fileVerboseLevel=fileVerboseLevel;
}

void setLogFile(FILE *outputFile){
    _outputFile=outputFile;
}

int verboseMsgPrint(int verboseLevel, const char *format, ...){
    int ret;
    va_list ap;
    if (_verboseLevel>=verboseLevel){
        va_start(ap, format);
        ret = vfprintf(stdout, format, ap);
        va_end(ap);
        return (ret);
    }
    
    if (_fileVerboseLevel>=verboseLevel){
        va_start(ap, format);
        ret = vfprintf(_outputFile, format, ap);
        va_end(ap);
        return (ret);
    }
    return 0;
}
