/* Generated by GOB (v2.0.15)   (do not edit directly) */



/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc.
 *
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com>
 */

#include <glib.h>
#include <glib-object.h>


/**
 * SECTION: writRecognAbsCharacter
 * @short_description: Abstract character.
 * @stability: Stable
 * @see_also: #writRecognRadical, #writRecognFullCharacter
 * @include: writrecogn-abscharacter.h
 *
 *
 * Basically, abstract characters are extension of radicals. 
 * It contains following extra information:
 * <ul>
 *    <li>Input Codes</li>
 *    <li>Language Set</li>
 *    <li>Variance Characters</li>
 * </ul>
 */
#ifndef ABS_CHARACTER_H_
#define ABS_CHARACTER_H_
#include <glib.h>
#include "WritRecogn.h"

#endif /* ABS_CHARACTER_H_ */

#ifndef __WRITRECOGN_ABSCHARACTER_H__
#define __WRITRECOGN_ABSCHARACTER_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/*
 * Type checking and casting macros
 */
#define WRITRECOGN_TYPE_ABSCHARACTER	(writrecogn_abscharacter_get_type())
#define WRITRECOGN_ABSCHARACTER(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_abscharacter_get_type(), writRecognAbsCharacter)
#define WRITRECOGN_ABSCHARACTER_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_abscharacter_get_type(), writRecognAbsCharacter const)
#define WRITRECOGN_ABSCHARACTER_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), writrecogn_abscharacter_get_type(), writRecognAbsCharacterClass)
#define WRITRECOGN_IS_ABSCHARACTER(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), writrecogn_abscharacter_get_type ())

#define WRITRECOGN_ABSCHARACTER_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), writrecogn_abscharacter_get_type(), writRecognAbsCharacterClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_WRITRECOGN_ABSCHARACTER__
#define __TYPEDEF_WRITRECOGN_ABSCHARACTER__
typedef struct _writRecognAbsCharacter writRecognAbsCharacter;
#endif
struct _writRecognAbsCharacter {
	writRecognRadical __parent__;
	/*< private >*/
	InputCodeRecList * inputCodeRecList; /* protected */
	RadicalList * varCharList; /* protected */
	LanguageSet * langAppearedSet; /* protected */
	GPtrArray * subRadical_sequence_H; /* protected */
	GPtrArray * subRadical_sequence_V; /* protected */
	CoordTree * coordTree_H; /* protected */
	CoordTree * coordTree_V; /* protected */
};

/*
 * Class definition
 */
typedef struct _writRecognAbsCharacterClass writRecognAbsCharacterClass;
struct _writRecognAbsCharacterClass {
	writRecognRadicalClass __parent__;
};


/*
 * Public methods
 */
GType	writrecogn_abscharacter_get_type	(void);
gpointer 	writrecogn_abscharacter_get_inputCodeRecList	(writRecognAbsCharacter * self);
void 	writrecogn_abscharacter_set_inputCodeRecList	(writRecognAbsCharacter * self,
					gpointer val);
GObject * 	writrecogn_abscharacter_get_varCharList	(writRecognAbsCharacter * self);
void 	writrecogn_abscharacter_set_varCharList	(writRecognAbsCharacter * self,
					GObject * val);
gpointer 	writrecogn_abscharacter_get_langAppearedSet	(writRecognAbsCharacter * self);
void 	writrecogn_abscharacter_set_langAppearedSet	(writRecognAbsCharacter * self,
					gpointer val);
AbsCharacter * 	writrecogn_abscharacter_new	(void);
void 	writrecogn_abscharacter_recompute_relativeBoundingBox	(writRecognAbsCharacter * self);
guint 	writrecogn_abscharacter_count_subRadical	(writRecognAbsCharacter * self);
GPtrArray * 	writrecogn_abscharacter_get_subRadical_sequence_H	(writRecognAbsCharacter * self);
void 	writrecogn_abscharacter_set_subRadical_sequence_H	(writRecognAbsCharacter * self,
					GPtrArray * radicalSequence);
GPtrArray * 	writrecogn_abscharacter_get_subRadical_sequence_V	(writRecognAbsCharacter * self);
void 	writrecogn_abscharacter_set_subRadical_sequence_V	(writRecognAbsCharacter * self,
					GPtrArray * radicalSequence);
guint 	writrecogn_abscharacter_count_variantCharacters	(writRecognAbsCharacter * self);
RadicalList * 	writrecogn_abscharacter_get_variantCharacterList	(writRecognAbsCharacter * self);
Radical * 	writrecogn_abscharacter_get_variantCharacter	(writRecognAbsCharacter * self,
					guint i,
					RadicalType type);
void 	writrecogn_abscharacter_insert_variantCharacter	(writRecognAbsCharacter * self,
					Radical * variantChar);
void 	writrecogn_abscharacter_insert_variantCharacter_by_code	(writRecognAbsCharacter * self,
					RadicalCode code);
guint 	writrecogn_abscharacter_count_inputCodeRecs	(writRecognAbsCharacter * self);
gboolean 	writrecogn_abscharacter_has_inputMethod	(writRecognAbsCharacter * self,
					InputMethod im);
InputCodeRec * 	writrecogn_abscharacter_find_inputCodeRec	(writRecognAbsCharacter * self,
					InputCodeRec * iRec);
InputCodeRec * 	writrecogn_abscharacter_get_inputCodeRec	(writRecognAbsCharacter * self,
					guint i);
gchar * 	writrecogn_abscharacter_get_inputCode	(writRecognAbsCharacter * self,
					InputMethod im);
gchar ** 	writrecogn_abscharacter_get_inputCode_array	(writRecognAbsCharacter * self,
					InputMethod im);
void 	writrecogn_abscharacter_reset_inputCodeRecList	(writRecognAbsCharacter * self);
gboolean 	writrecogn_abscharacter_append_inputCodeRec	(writRecognAbsCharacter * self,
					InputCodeRec * iRec);
gboolean 	writrecogn_abscharacter_remove_inputCodeRec	(writRecognAbsCharacter * self,
					InputCodeRec * iRec);
gboolean 	writrecogn_abscharacter_add_language	(writRecognAbsCharacter * self,
					SupportedLanguage lang);
gboolean 	writrecogn_abscharacter_add_language_string	(writRecognAbsCharacter * self,
					const gchar * langStr);
gboolean 	writrecogn_abscharacter_has_language	(writRecognAbsCharacter * self,
					SupportedLanguage lang);

/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define WRITRECOGN_ABSCHARACTER_PROP_INPUTCODERECLIST(arg)    	"inputCodeRecList", __extension__ ({gpointer z = (arg); z;})
#define WRITRECOGN_ABSCHARACTER_GET_PROP_INPUTCODERECLIST(arg)	"inputCodeRecList", __extension__ ({gpointer *z = (arg); z;})
#define WRITRECOGN_ABSCHARACTER_PROP_VARCHARLIST(arg)    	"varCharList", __extension__ ({GObject *z = (arg); z;})
#define WRITRECOGN_ABSCHARACTER_GET_PROP_VARCHARLIST(arg)	"varCharList", __extension__ ({GObject **z = (arg); z;})
#define WRITRECOGN_ABSCHARACTER_PROP_LANGAPPEAREDSET(arg)    	"langAppearedSet", __extension__ ({gpointer z = (arg); z;})
#define WRITRECOGN_ABSCHARACTER_GET_PROP_LANGAPPEAREDSET(arg)	"langAppearedSet", __extension__ ({gpointer *z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define WRITRECOGN_ABSCHARACTER_PROP_INPUTCODERECLIST(arg)    	"inputCodeRecList",(gpointer )(arg)
#define WRITRECOGN_ABSCHARACTER_GET_PROP_INPUTCODERECLIST(arg)	"inputCodeRecList",(gpointer *)(arg)
#define WRITRECOGN_ABSCHARACTER_PROP_VARCHARLIST(arg)    	"varCharList",(GObject *)(arg)
#define WRITRECOGN_ABSCHARACTER_GET_PROP_VARCHARLIST(arg)	"varCharList",(GObject **)(arg)
#define WRITRECOGN_ABSCHARACTER_PROP_LANGAPPEAREDSET(arg)    	"langAppearedSet",(gpointer )(arg)
#define WRITRECOGN_ABSCHARACTER_GET_PROP_LANGAPPEAREDSET(arg)	"langAppearedSet",(gpointer *)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
