/* Generated by GOB (v2.0.15)   (do not edit directly) */



/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc.
 *
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com>
 */

#include <glib.h>
#include <glib-object.h>



/**
 * SECTION: writRecognFullCharacter
 * @short_description: Full character that hold all information about the character
 * @stability: Stable
 * @see_also: #writRecognRadical, #writRecognAbsCharacter
 * @include: writrecogn-abscharacter.h
 *
 * Full character hold all information about the character. 
 * Specifically, RawStrokes. 
 *
 */

#ifndef FULL_CHARACTER_H_
#define FULL_CHARACTER_H_
#include "utils.h"
#include "WritRecogn.h"

/**
 * RawWriting:
 * @writingId: a serial number that identifies a RawWriting, start at 1.
 * @writingRadical: a radical that  shows how a character is formed by RawStrokes.
 *
 * A RawWriting instance demonstrates how this character are written by a user.
 * It consists a stroke sequence (@rawStrokeArray) that 
 */
struct _RawWriting {
    gint writingId; 
    Radical *writingRadical;
};

//RawWriting *rawWriting_add_rawStroke(RawWriting* rW,RawStroke *rStroke);
#define DEFAULT_RAWWRITING_INDEX 0

void rawWriting_reset(RawWriting *rW);

#endif /* FULL_CHARACTER_H_ */

#ifndef __WRITRECOGN_FULLCHARACTER_H__
#define __WRITRECOGN_FULLCHARACTER_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/*
 * Type checking and casting macros
 */
#define WRITRECOGN_TYPE_FULLCHARACTER	(writrecogn_fullcharacter_get_type())
#define WRITRECOGN_FULLCHARACTER(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_fullcharacter_get_type(), writRecognFullCharacter)
#define WRITRECOGN_FULLCHARACTER_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_fullcharacter_get_type(), writRecognFullCharacter const)
#define WRITRECOGN_FULLCHARACTER_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), writrecogn_fullcharacter_get_type(), writRecognFullCharacterClass)
#define WRITRECOGN_IS_FULLCHARACTER(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), writrecogn_fullcharacter_get_type ())

#define WRITRECOGN_FULLCHARACTER_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), writrecogn_fullcharacter_get_type(), writRecognFullCharacterClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_WRITRECOGN_FULLCHARACTER__
#define __TYPEDEF_WRITRECOGN_FULLCHARACTER__
typedef struct _writRecognFullCharacter writRecognFullCharacter;
#endif
struct _writRecognFullCharacter {
	writRecognAbsCharacter __parent__;
	/*< private >*/
	GArray * rawWritingArray; /* protected */
};

/*
 * Class definition
 */
typedef struct _writRecognFullCharacterClass writRecognFullCharacterClass;
struct _writRecognFullCharacterClass {
	writRecognAbsCharacterClass __parent__;
};


/*
 * Public methods
 */
GType	writrecogn_fullcharacter_get_type	(void);
FullCharacter * 	writrecogn_fullcharacter_new	(void);
RawWriting * 	writrecogn_fullcharacter_new_rawWriting	(writRecognFullCharacter * self);
guint 	writrecogn_fullcharacter_count_rawWritings	(writRecognFullCharacter * self);
RawWriting * 	writrecogn_fullcharacter_get_rawWriting	(writRecognFullCharacter * self,
					gint index);
void 	writrecogn_fullcharacter_remove_rawWriting	(writRecognFullCharacter * self,
					guint i);
void 	writrecogn_fullcharacter_reset_rawWriting	(writRecognFullCharacter * self,
					guint i);
guint 	writrecogn_fullcharacter_count_rawStrokes	(writRecognFullCharacter * self,
					gint rawWritingId);
RawStroke * 	writrecogn_fullcharacter_get_rawStroke	(writRecognFullCharacter * self,
					gint rawWritingIndex,
					guint i);
void 	writrecogn_fullcharacter_add_rawStroke	(writRecognFullCharacter * self,
					gint rawWritingIndex,
					RawStroke * rStroke);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
