/* Generated by GOB (v2.0.15)   (do not edit directly) */



/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc.
 *
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com>
 */

#include <glib.h>
#include <glib-object.h>


/**
 * SECTION: writRecognRadical_list
 * @short_description: RadicalList is a wrapper class to access a list of Radical
 * @stability: Stable
 * @see_also: #writRecognRadical
 * @include: writrecogn-radical_list.h
 *
 * RadicalList is a wrapper class to access a list of Radical.
 *
 * It can be used to pass the universal set in database, 
 * or store the returned results.
 */
#ifndef RADICAL_LIST_H_
#define RADICAL_LIST_H_
#include "fileProcessing.h"
#include "WritRecogn.h"
#include "collection.h"

extern gboolean free_codeArray;
#endif  /* RADICAL_LIST_H_ */

#ifndef __WRITRECOGN_RADICAL_LIST_H__
#define __WRITRECOGN_RADICAL_LIST_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/*
 * Type checking and casting macros
 */
#define WRITRECOGN_TYPE_RADICAL_LIST	(writrecogn_radical_list_get_type())
#define WRITRECOGN_RADICAL_LIST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_radical_list_get_type(), writRecognRadical_list)
#define WRITRECOGN_RADICAL_LIST_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_radical_list_get_type(), writRecognRadical_list const)
#define WRITRECOGN_RADICAL_LIST_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), writrecogn_radical_list_get_type(), writRecognRadical_listClass)
#define WRITRECOGN_IS_RADICAL_LIST(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), writrecogn_radical_list_get_type ())

#define WRITRECOGN_RADICAL_LIST_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), writrecogn_radical_list_get_type(), writRecognRadical_listClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_WRITRECOGN_RADICAL_LIST__
#define __TYPEDEF_WRITRECOGN_RADICAL_LIST__
typedef struct _writRecognRadical_list writRecognRadical_list;
#endif
struct _writRecognRadical_list {
	GObject __parent__;
	/*< private >*/
	GArray * codeArray; /* protected */
	CharacterDataFile * backedDataFile; /* protected */
};

/*
 * Class definition
 */
typedef struct _writRecognRadical_listClass writRecognRadical_listClass;
struct _writRecognRadical_listClass {
	GObjectClass __parent__;
	void (* copy) (writRecognRadical_list * self, RadicalList * src);
	void (* reset) (writRecognRadical_list * self);
};


/*
 * Public methods
 */
GType	writrecogn_radical_list_get_type	(void);
gpointer 	writrecogn_radical_list_get_codeArray	(writRecognRadical_list * self);
void 	writrecogn_radical_list_set_codeArray	(writRecognRadical_list * self,
					gpointer val);
GObject * 	writrecogn_radical_list_get_backedDataFile	(writRecognRadical_list * self);
void 	writrecogn_radical_list_set_backedDataFile	(writRecognRadical_list * self,
					GObject * val);
RadicalList * 	writrecogn_radical_list_new	(void);
RadicalList * 	writrecogn_radical_list_new_from_datafile	(CharacterDataFile * datafile);
gpointer 	writrecogn_radical_list_free	(writRecognRadical_list * self,
					gboolean free_code_array);
guint 	writrecogn_radical_list_size	(writRecognRadical_list * self);
void 	writrecogn_radical_list_copy	(writRecognRadical_list * self,
					RadicalList * src);
void 	writrecogn_radical_list_reset	(writRecognRadical_list * self);
void 	writrecogn_radical_list_append_radical	(writRecognRadical_list * self,
					Radical * rad);
void 	writrecogn_radical_list_append_radicalCode	(writRecognRadical_list * self,
					RadicalCode code);
void 	writrecogn_radical_list_append_radicalCode_array	(writRecognRadical_list * self,
					GArray * codeArray);
gboolean 	writrecogn_radical_list_has_radicalCode	(writRecognRadical_list * self,
					RadicalCode code);
gint 	writrecogn_radical_list_find_radical_index	(writRecognRadical_list * self,
					RadicalCode code);
Radical * 	writrecogn_radical_list_find_radical_by_utf8	(writRecognRadical_list * self,
					const gchar * utf8Code,
					RadicalType type);
Radical * 	writrecogn_radical_list_find_radical_by_code	(writRecognRadical_list * self,
					RadicalCode code,
					RadicalType type);
Radical * 	writrecogn_radical_list_get_radical_by_index	(writRecognRadical_list * self,
					const gint index,
					RadicalType type);
gboolean 	writrecogn_radical_list_insert_radical_datafile	(writRecognRadical_list * self,
					Radical * rad);
gboolean 	writrecogn_radical_list_update_radical_datafile	(writRecognRadical_list * self,
					Radical * rad,
					RadicalType type);
RadicalList * 	writrecogn_radical_list_find_matches	(writRecognRadical_list * self,
					RadicalQuery * query);
gboolean 	writrecogn_radical_list_is_empty	(writRecognRadical_list * self);

/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define WRITRECOGN_RADICAL_LIST_PROP_CODEARRAY(arg)    	"codeArray", __extension__ ({gpointer z = (arg); z;})
#define WRITRECOGN_RADICAL_LIST_GET_PROP_CODEARRAY(arg)	"codeArray", __extension__ ({gpointer *z = (arg); z;})
#define WRITRECOGN_RADICAL_LIST_PROP_BACKEDDATAFILE(arg)    	"backedDataFile", __extension__ ({GObject *z = (arg); z;})
#define WRITRECOGN_RADICAL_LIST_GET_PROP_BACKEDDATAFILE(arg)	"backedDataFile", __extension__ ({GObject **z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define WRITRECOGN_RADICAL_LIST_PROP_CODEARRAY(arg)    	"codeArray",(gpointer )(arg)
#define WRITRECOGN_RADICAL_LIST_GET_PROP_CODEARRAY(arg)	"codeArray",(gpointer *)(arg)
#define WRITRECOGN_RADICAL_LIST_PROP_BACKEDDATAFILE(arg)    	"backedDataFile",(GObject *)(arg)
#define WRITRECOGN_RADICAL_LIST_GET_PROP_BACKEDDATAFILE(arg)	"backedDataFile",(GObject **)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
