/* Generated by GOB (v2.0.15)   (do not edit directly) */



/*
 * Copyright © 2007  Red Hat, Inc. All rights reserved.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License v.2. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY expressed
 * or implied, including the implied warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA. Any Red Hat trademarks that are incorporated in
 * the source code or documentation are not subject to the GNU General
 * Public License and may only be used or replicated with the express
 * permission of Red Hat, Inc.
 *
 * Red Hat Author(s): Ding-Yi Chen <dchen@redhat.com>
 */

#include <glib.h>
#include <glib-object.h>


/**
 * SECTION:writRecognRawStroke
 * @short_description: Raw stroke, user drawn stroke.
 * @stability: Stable
 * @see_also: #writRecognRadical, #writRecognFullCharacter
 * @include: writrecogn-rawstroke.h
 *
 * GOB2 generate the class name as <code>writRecognRawStroke</code>,
 * Use alias <b>RawStroke</b> for convenience.
 *
 * A raw stroke is also a radical, except it stores the user drawn stroke,
 * which is represent as a sequence of RawStrokeNode.
 * RawStrokeNode is defined as a 2-D point in a 1000x1000 canvas.
 */

#ifndef RAW_STROKE_H_
#define RAW_STROKE_H_
#include "WritRecogn.h"
#include "utils.h"
#define rawStrokeNode_get_coordinate2D(node) (Coordinate2D *) node

gfloat rawStrokeNode_distance(RawStrokeNode *node1, RawStrokeNode *node2);

gfloat rawStrokeNode_distance_fromLine(RawStrokeNode *targetNode,RawStrokeNode *startNode,RawStrokeNode *endNode);

void boundingBox_add_rawStrokeNode(BoundingBox *box,RawStrokeNode *node);
#endif /* RAW_STROKE_H_ */
/**
 * writRecognRawStroke:
 *  @rawStrokelArray: (protected) Array that actually holds raw stroke node. 
 *      Type contained: RawStrokeNode
 */

#ifndef __WRITRECOGN_RAWSTROKE_H__
#define __WRITRECOGN_RAWSTROKE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/*
 * Type checking and casting macros
 */
#define WRITRECOGN_TYPE_RAWSTROKE	(writrecogn_rawstroke_get_type())
#define WRITRECOGN_RAWSTROKE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_rawstroke_get_type(), writRecognRawStroke)
#define WRITRECOGN_RAWSTROKE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), writrecogn_rawstroke_get_type(), writRecognRawStroke const)
#define WRITRECOGN_RAWSTROKE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), writrecogn_rawstroke_get_type(), writRecognRawStrokeClass)
#define WRITRECOGN_IS_RAWSTROKE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), writrecogn_rawstroke_get_type ())

#define WRITRECOGN_RAWSTROKE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), writrecogn_rawstroke_get_type(), writRecognRawStrokeClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_WRITRECOGN_RAWSTROKE__
#define __TYPEDEF_WRITRECOGN_RAWSTROKE__
typedef struct _writRecognRawStroke writRecognRawStroke;
#endif
struct _writRecognRawStroke {
	writRecognRadical __parent__;
	/*< private >*/
	GArray * rawStrokeNodeArray; /* protected */
};

/*
 * Class definition
 */
typedef struct _writRecognRawStrokeClass writRecognRawStrokeClass;
struct _writRecognRawStrokeClass {
	writRecognRadicalClass __parent__;
};


/*
 * Public methods
 */
GType	writrecogn_rawstroke_get_type	(void);
RawStroke * 	writrecogn_rawstroke_new	(void);
guint 	writrecogn_rawstroke_count_rawStrokeNodes	(writRecognRawStroke * self);
RawStrokeNode * 	writrecogn_rawstroke_get_rawStrokeNode	(writRecognRawStroke * self,
					int i);
guint 	writrecogn_rawstroke_add_rawStrokeNode	(writRecognRawStroke * self,
					gint x,
					gint y);
void 	writrecogn_rawstroke_remove_rawStrokeNode	(writRecognRawStroke * self,
					int i);
gfloat 	writrecogn_rawstroke_sum_length	(writRecognRawStroke * self);
gfloat 	writrecogn_rawstroke_rawStrokeNodes_direct_distance	(writRecognRawStroke * self,
					gint startIndex,
					gint endIndex);
gfloat 	writrecogn_rawstroke_distanceOf_rawStrokeNode	(writRecognRawStroke * self,
					gint startIndex,
					gint endIndex,
					gint rawStrokenodeIndex);
gint 	writrecogn_rawstroke_find_farest_node	(writRecognRawStroke * self,
					int startIndex,
					int endIndex);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
